package com.eactive.eai.rms.onl.manage.adapter.spcftmadapterhistory;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import com.eactive.eai.rms.common.base.OnlBaseAnnotationController;
import com.eactive.eai.rms.common.combo.ComboService;
import com.eactive.eai.rms.common.combo.ComboVo;
import com.eactive.eai.rms.common.util.CamelCaseUtil;
import com.eactive.eai.rms.common.vo.JsonPageVo;
import com.google.gson.Gson;

@Controller
@SuppressWarnings("unchecked")
public class SpcfTmAdapterHIstoryController extends OnlBaseAnnotationController {

	@Autowired
	@Qualifier("spcfTmAdapterHistoryService")
	private SpcfTmAdapterHistoryService service;

	@Autowired
	private ComboService comboService;

	@RequestMapping(value = "/onl/admin/adapter/spcfTmAdapterHistoryMan.view")
	private String viewList(HttpServletRequest request, @RequestParam(value = "cmd", required = false) String cmd)
			throws Exception {
		if (cmd == null || "LIST".equals(cmd.toUpperCase())) {
			cmd = "";
		} else {
			cmd = CamelCaseUtil.converCamelCase(cmd);
		}
		String path = request.getServletPath();
		return path.split("[.]")[0] + cmd;
	}

	/**
	 * @param request
	 * @param response
	 * @throws Exception
	 */
	@RequestMapping(value = "/onl/admin/adapter/spcfTmAdapterHistoryMan.json", params = "cmd=LIST")
	private ModelAndView selectList(HttpServletRequest request, JsonPageVo pageVo, String searchAdptrBzwkGroupName,
			String searchAdptrStartHms, String searchAdptrStopHms, String searchAdptrMngDstCd,
			String searchAdptrEvtStatus) throws Exception {

		HashMap map = service
				.selectList(pageVo.getStartNum(), pageVo.getEndNum(), searchAdptrBzwkGroupName, searchAdptrStartHms,
						searchAdptrStopHms, searchAdptrMngDstCd, searchAdptrEvtStatus);

		pageVo.setTotalCount((Integer) map.get("totalCount"));

		Map resultMap = new HashMap();
		resultMap.put("total", pageVo.getTotal()); // 전체 페이지수
		resultMap.put("page", pageVo.getPage()); // 현재 페이지수
		resultMap.put("records", pageVo.getTotalCount());// 전체 레코드건수
		resultMap.put("rows", map.get("list"));

		ModelAndView modelAndView = new ModelAndView("jsonView", resultMap);
		return modelAndView;

	}

	@RequestMapping(value = "/onl/admin/adapter/spcfTmAdapterHistoryMan.json", params = "cmd=DETAIL")
	private ModelAndView selectDetail(HttpServletRequest request, HttpServletResponse response,
			String adptrBzwkGroupName, String adptrEventHms) throws Exception {
		HashMap map = service.selectDetail(adptrBzwkGroupName, adptrEventHms);

		ModelAndView modelAndView = new ModelAndView("jsonView", map);

		return modelAndView;
	}

	@RequestMapping(value = "/onl/admin/adapter/spcfTmAdapterHistoryMan.json", params = "cmd=LIST_INIT_COMBO")
	public ModelAndView initCombo(HttpServletRequest request, HttpServletResponse response, String eaiSvcName) {
		List<ComboVo> listAdapter = comboService.getFromAdapterGroup();
		List<ComboVo> listAdptrTypes = comboService.getFromCode("ADTR_DST_CD");

		Map<String, Object> resultMap = new HashMap<>();
		resultMap.put("adapterRows", listAdapter);
		resultMap.put("adptrTypeRows", listAdptrTypes);

		return new ModelAndView("jsonView", resultMap);
	}

	@RequestMapping(value = "/onl/admin/adapter/spcfTmAdapterHistoryMan.json", params = "cmd=DELETE")
	private String delete(HttpServletRequest request, HttpServletResponse response,
			@RequestParam HashMap<String, Object> map) throws Exception {

		// service.delete(map);
		return null;

	}

	@RequestMapping(value = "/onl/admin/adapter/spcfTmAdapterHistoryMan.excel", params = "cmd=LIST_GRID_TO_EXCEL")
	public ModelAndView listGridToExcel(HttpServletRequest request, HttpServletResponse response,
			@RequestParam HashMap<String, Object> paramMap) throws Exception {
		HashMap<String, Object> resultMap = new HashMap<String, Object>();

		String headersStr = (String) paramMap.get("headersStr");
		headersStr = headersStr.substring(0, headersStr.length() - 1);
		paramMap.put("headersStr", headersStr);

		Gson gson = new Gson();
		@SuppressWarnings("unchecked")

		HashMap<String, Object> list = service.selectListToExcel(paramMap);

		String jsonStr = gson.toJson(list.get("list"));
		HashMap<String, Object>[] list2 = gson.fromJson(jsonStr, HashMap[].class);

		String[] headers = gson.fromJson((String) paramMap.get("header"), String[].class);
		String[] headerTitles = gson.fromJson((String) paramMap.get("headerTitle"), String[].class);

		HashMap<String, Object>[] lmerge = null;
		String merge = (String) paramMap.get("merge");
		if (merge != null) {
			lmerge = gson.fromJson(merge, HashMap[].class);
		}

		resultMap.put("headers", headers);
		resultMap.put("headerTitles", headerTitles);
		resultMap.put("datas", list2);
		resultMap.put("fileName", (String) paramMap.get("fileName"));
		resultMap.put("merge", lmerge);
		ModelAndView modelAndView = new ModelAndView("excelView", resultMap);
		return modelAndView;
	}
}
